package com.tibco.utils.scheduler.job;

import org.quartz.Job;
import org.quartz.JobDataMap;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

import com.streambase.sb.Schema;
import com.streambase.sb.StreamBaseException;
import com.streambase.sb.Tuple;
import com.streambase.sb.TupleException;
import com.tibco.utils.scheduler.TasksScheduler;

public class SchedulerJob implements Job {

	@Override
	public void execute(JobExecutionContext context) throws JobExecutionException {
		JobDataMap jobDataMap = context.getJobDetail().getJobDataMap();
		TasksScheduler operator = (TasksScheduler) jobDataMap.get(TasksScheduler.JOB_DATA_OPERATOR_INSTANCE);
		
		Tuple scheduleConfigurationTuple = (Tuple) jobDataMap.get(TasksScheduler.JOB_DATA_SCHEDULE_CONFIGURATION_TUPLE);
		if(operator != null){
			Schema outputSchema = operator.getOutputSchema(0);
			Tuple out = outputSchema.createTuple();
			try {
				out.setTuple(TasksScheduler.scheduleConfigurationFieldName, scheduleConfigurationTuple);
			} catch (TupleException e) {
				throw new JobExecutionException("Failed to set the field to the ouptut tuple.",e);
			}
			// nextOutputPort is used to send tuples by round-robin on every output port by this template.
			try {
				operator.sendOutput(0, out);
			} catch (StreamBaseException e) {
				throw new JobExecutionException("Failed send the output tuple.",e);
			}

		}
	}

}
